Description

The gvSIG native libraries path is added after the system one, so the system libraries are loaded first. This can cause issues like those
described in #3848 and #4013. So the gvSIG native libraries (e.g. GDAL/OGR ones) should be loaded first in gvSIG.sh:

###################################################################
# gvSIG native libraries location
###################################################################

export GVSIG_NATIVE_LIBS="" 
export LD_LIBRARY_PATH="" 
export PATH

add_library_path() {
  #logger_info "add_library_path $1" 
  LD_LIBRARY_PATH="$1${CPSEP}$LD_LIBRARY_PATH" 
  GVSIG_NATIVE_LIBS="$1${CPSEP}$GVSIG_NATIVE_LIBS" 
  PATH="$1${CPSEP}$PATH" 
}

list_shared_library_dependencies() {
  logger_info "Checking shared library dependencies for $1" 
  if [ "$OS" = "win" ] ; then
        logger_cmd ./cygcheck.exe "$1" 
  else
        logger_cmd ldd "$1" 
  fi || logger_warn "Problems checking shared library $1"  || true
}

add_classpath() {
  GVSIG_CLASSPATH="$1${CPSEP}$GVSIG_CLASSPATH" 
}

Related to #3848 and #4013.
Associated revisions
Revision 42667 - 02/01/2016 09:03 PM - Joaquín  del Cerro Murciano

refs #4042, cambiado el orden de busqueda de las nativas para que primero busque en la instalacion de gvSIG y luego en el sistema.

Revision 42675 - 02/02/2016 06:09 PM - Joaquín  del Cerro Murciano

refs #4042

Revision 42723 - 02/15/2016 10:31 AM - Joaquín  del Cerro Murciano

refs  #4042, corregido para que en linux use primero las nativas que lleva gvSIG y despues las del sistema.

History
#1 - 01/22/2016 11:53 AM - Antonio Falciano

I've tested the fix reported above and found that it helps to prevent issues like #3848 and #4013. Because we can't isolate gvSIG in a virtual
environment (because it depends by some system libraries), we have to load its libraries before than the system ones.

#2 - 01/28/2016 12:00 PM - Antonio Falciano
- File gvsigsh_path.patch added

In order to reproduce the issue on a win machine:
    -  install the GDAL/OGR libraries standalone (or coming from OSGeo4W), e.g. 1.11.0 version;
    -  add the GDAL binary folder to the PATH environmental variable;
    -  execute gvSIG and then check the gvSIG-launcher.log.

Result: checking the shared library dependencies of gdaljni.dll used by gvSIG, you'll see the GDAL system dlls among the dependencies and not the
gvSIG one. So the GDAL system libraries are loaded accidentally instead of gvSIG ones.

Solution: we need only to invert the order of concatenation of PATH variable to avoid to "see" GDAL/OGR libraries eventually installed on the system
before than gvSIG ones. I attach a patch that solves the issue.

Has patch: yes

#3 - 02/01/2016 09:04 PM - Joaquín  del Cerro Murciano
- Target version changed from 2.3.0-2447-final (rev. org.gvsig.desktop-2.0.153) to 2.3.0-2418 (rev. org.gvsig.desktop-2.0.124)
- Assignee set to Joaquín  del Cerro Murciano
- Status changed from New to Fixed

#4 - 02/02/2016 03:56 PM - Antonio Falciano
- Target version changed from 2.3.0-2418 (rev. org.gvsig.desktop-2.0.124) to 2.3.0-2447-final (rev. org.gvsig.desktop-2.0.153)
- Status changed from Fixed to New

Hi Joaquin, 
it should be:
add_library_path() {
  #logger_info "add_library_path $1" 
  LD_LIBRARY_PATH="$1${CPSEP}$LD_LIBRARY_PATH" 
  GVSIG_NATIVE_LIBS="$1${CPSEP}$GVSIG_NATIVE_LIBS" 
  PATH="$1${CPSEP}$PATH" 
}

The $ is missing before {CPSEP} in build 2418, so I reopen the ticket.

#5 - 02/02/2016 06:08 PM - Joaquín  del Cerro Murciano
- Target version changed from 2.3.0-2447-final (rev. org.gvsig.desktop-2.0.153) to 2.3.0-2419  (rev. org.gvsig.desktop-2.0.125)

Antonio Falciano wrote:

Hi Joaquin, 
it should be:
[...]The $ is missing before {CPSEP} in build 2418, so I reopen the ticket.

Aaayyy ya lo he visto, que error tan tonto... lo corrijo y hago otro build.
Gracias.

#6 - 02/02/2016 06:14 PM - Joaquín  del Cerro Murciano
- Status changed from New to Fixed

#7 - 02/03/2016 09:59 AM - Antonio Falciano
- Status changed from Fixed to Closed

Files
gvsigsh_path.patch 1.05 KB 01/28/2016 Antonio Falciano
